// BonTsDump.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <windows.h>
#include <commdlg.h>
#include <tchar.h>
#include <stdio.h>
#include <wchar.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <signal.h>
#include "IBonDriver2.h"
#include "getopt.h"

typedef IBonDriver* (*PCREATEBONDRIVER)(void);
IBonDriver2* myIBD;

void SignalHandler(int signal)
{
	myIBD->CloseTuner();
	myIBD->Release();
	fwprintf(stderr,L"terminating BonTsDump on signal %d\n",signal);
	exit(0);
}


int _tmain(int argc, _TCHAR* argv[])
{
	HMODULE hBonDriver;
	PCREATEBONDRIVER pCreateBonDriver;
	DWORD dw,dwB;
	BYTE *pBuf;
	int opt,freq=25;
	LPCWSTR driverName;

    signal(SIGINT, SignalHandler);
    signal(SIGTERM, SignalHandler);

	while((opt=getopt(argc, argv,L"f:c:o"))!=-1){
		switch(opt){
		case 'o':break;
		case 'c':
			driverName=optarg;
			break;
		case 'f':
			freq=_wtoi(optarg);	
			break;
		default:break;
		}
//		wprintf(L"%c / %s\n",opt,optarg);
	}
//	wprintf(L"freq = %d\n",freq);
	if(NULL==(hBonDriver = LoadLibrary(driverName))){
		fwprintf(stderr,L"can not load %s\n",driverName);
		exit(-1);
	}
	pCreateBonDriver = (PCREATEBONDRIVER)GetProcAddress(hBonDriver, "CreateBonDriver");

	myIBD = dynamic_cast<IBonDriver2*>(pCreateBonDriver());
	myIBD->OpenTuner();
	myIBD->SetChannel(0,freq-13);
	myIBD->PurgeTsStream();
	_setmode(_fileno(stdout),_O_BINARY);
	while(1){
		while(myIBD->GetReadyCount())
			if(myIBD->GetTsStream(&pBuf, &dw, &dwB))
				_write(_fileno(stdout), pBuf, dw);
			else
				Sleep(0);
		Sleep(100);
	}
	myIBD->CloseTuner();
	myIBD->Release();
	return 0;
}
